struct dot11_mgmt {
	uint16_t frame_control;
	uint16_t duration;
	uint8_t da[6];
	uint8_t sa[6];
	uint8_t bssid[6];
	uint16_t seq_ctrl;
};


/* frame types */
#define DOT11_FTYPE_MGMT		0x0000
#define DOT11_FTYPE_CTL			0x0004
#define DOT11_FTYPE_DATA		0x0008



/* management */
#define DOT11_STYPE_ASSOC_REQ		0x0000
#define DOT11_STYPE_ASSOC_RESP		0x0010
#define DOT11_STYPE_REASSOC_REQ		0x0020
#define DOT11_STYPE_REASSOC_RESP	0x0030
#define DOT11_STYPE_PROBE_REQ		0x0040
#define DOT11_STYPE_PROBE_RESP		0x0050
#define DOT11_STYPE_BEACON		0x0080
#define DOT11_STYPE_ATIM		0x0090
#define DOT11_STYPE_DISASSOC		0x00A0
#define DOT11_STYPE_AUTH		0x00B0
#define DOT11_STYPE_DEAUTH		0x00C0
#define DOT11_STYPE_ACTION		0x00D0

/* control */
#define DOT11_STYPE_BACK_REQ		0x0080
#define DOT11_STYPE_BACK		0x0090
#define DOT11_STYPE_PSPOLL		0x00A0
#define DOT11_STYPE_RTS			0x00B0
#define DOT11_STYPE_CTS			0x00C0
#define DOT11_STYPE_ACK			0x00D0
#define DOT11_STYPE_CFEND		0x00E0
#define DOT11_STYPE_CFENDACK		0x00F0

/* data */
#define DOT11_STYPE_DATA		0x0000
#define DOT11_STYPE_DATA_CFACK		0x0010
#define DOT11_STYPE_DATA_CFPOLL		0x0020
#define DOT11_STYPE_DATA_CFACKPOLL	0x0030
#define DOT11_STYPE_NULLFUNC		0x0040
#define DOT11_STYPE_CFACK		0x0050
#define DOT11_STYPE_CFPOLL		0x0060
#define DOT11_STYPE_CFACKPOLL		0x0070
#define DOT11_STYPE_QOS_DATA		0x0080
#define DOT11_STYPE_QOS_DATA_CFACK	0x0090
#define DOT11_STYPE_QOS_DATA_CFPOLL	0x00A0
#define DOT11_STYPE_QOS_DATA_CFACKPOLL	0x00B0
#define DOT11_STYPE_QOS_NULLFUNC	0x00C0
#define DOT11_STYPE_QOS_CFACK		0x00D0
#define DOT11_STYPE_QOS_CFPOLL		0x00E0
#define DOT11_STYPE_QOS_CFACKPOLL	0x00F0

